import { Command } from '@seagull/commands';
import { AddLogRequest } from '@seagull/libraries';
import * as AWS from 'aws-sdk';
import { PutLogEventsRequest, PutLogEventsResponse } from 'aws-sdk/clients/cloudwatchlogs';
import { PromiseResult } from 'aws-sdk/lib/request';
interface LogStreamName {
    logStreamName?: string;
}
interface CustomPutResponse extends LogStreamName, PutLogEventsResponse {
}
export declare class AddLog extends Command<PromiseResult<CustomPutResponse, AWS.AWSError>> {
    params: PutLogEventsRequest;
    CWL: AWS.CloudWatchLogs;
    executeCloud: () => Promise<AWS.CloudWatchLogs.PutLogEventsResponse & {
        $response: AWS.Response<AWS.CloudWatchLogs.PutLogEventsResponse, AWS.AWSError>;
    } & {
        logStreamName: string;
    }>;
    executePure: () => Promise<AWS.CloudWatchLogs.PutLogEventsResponse & {
        $response: AWS.Response<AWS.CloudWatchLogs.PutLogEventsResponse, AWS.AWSError>;
    } & {
        logStreamName: string;
    }>;
    executeConnected: () => Promise<AWS.CloudWatchLogs.PutLogEventsResponse & {
        $response: AWS.Response<AWS.CloudWatchLogs.PutLogEventsResponse, AWS.AWSError>;
    } & {
        logStreamName: string;
    }>;
    executeEdge: () => Promise<AWS.CloudWatchLogs.PutLogEventsResponse & {
        $response: AWS.Response<AWS.CloudWatchLogs.PutLogEventsResponse, AWS.AWSError>;
    } & {
        logStreamName: string;
    }>;
    constructor(params: AddLogRequest);
    execute(): Promise<PromiseResult<CustomPutResponse, AWS.AWSError>>;
    revert(): Promise<any>;
    private exec;
}
export {};
