"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const testing_1 = require("@seagull/testing");
require("chai/register-should");
const mocha_typescript_1 = require("mocha-typescript");
const src_1 = require("../src");
let Test = class Test extends testing_1.BasicTest {
    constructor() {
        super(...arguments);
        this.mocks = [];
    }
    'can create log stream and add muliple logs'() {
        return __awaiter(this, void 0, void 0, function* () {
            const log1 = [
                { bar: 'Foo' },
                'TEST TEST',
                [23, 'Hello World', null, { foo: 'bar' }],
            ];
            const log2 = ['FOO', 'BAR'];
            const stream = yield new src_1.CreateStream({
                logStreamName: 'addLogTest',
            }).execute();
            const command1 = new src_1.AddLog({ logStreamName: stream, log: log1 });
            yield command1.execute();
            const command2 = new src_1.AddLog({ logStreamName: stream, log: log2 });
            yield command2.execute();
            const returnedLogs = yield new src_1.ReadLog({
                logStreamName: stream,
            }).execute();
            returnedLogs.events.should.be.an('array').with.lengthOf(2);
            returnedLogs.events[0].message.should.be.a('string');
            returnedLogs.events[0].timestamp.should.be.a('number');
        });
    }
    'revert method should be a no-op'() {
        return __awaiter(this, void 0, void 0, function* () {
            const logs = [
                { bar: 'Foo' },
                'TEST TEST',
                [23, 'Hello World', null, { foo: 'bar' }],
            ];
            const command = new src_1.AddLog({
                log: logs,
                logLevel: 'error',
                logStreamName: 'readLog',
            });
            const result = yield command.revert();
            (result === undefined).should.be.equal(true);
        });
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], Test.prototype, "can create log stream and add muliple logs", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], Test.prototype, "revert method should be a no-op", null);
Test = __decorate([
    mocha_typescript_1.suite('commands-logging::AddLog')
], Test);
exports.Test = Test;
//# sourceMappingURL=add_log.js.map