"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const testing_1 = require("@seagull/testing");
require("chai/register-should");
const mocha_typescript_1 = require("mocha-typescript");
const src_1 = require("../src");
let Test = class Test extends testing_1.BasicTest {
    constructor() {
        super(...arguments);
        this.mocks = [];
    }
    'can list all streams'() {
        return __awaiter(this, void 0, void 0, function* () {
            const log = [
                { bar: 'Foo' },
                'TEST TEST',
                [23, 'Hello World', null, { foo: 'bar' }],
            ];
            const stream = yield new src_1.CreateStream({
                logStreamName: 'stream_1',
            }).execute();
            yield new src_1.AddLog({ log, logStreamName: stream }).execute();
            const stream2 = yield new src_1.CreateStream({
                logStreamName: 'stream_2',
            }).execute();
            yield new src_1.AddLog({ log, logStreamName: stream2 }).execute();
            const otherStream = yield new src_1.CreateStream({
                logStreamName: 'otherStream',
            }).execute();
            yield new src_1.AddLog({ log, logStreamName: otherStream }).execute();
            const streams = yield new src_1.ListStreams({
                logStreamNamePrefix: 'stream_',
            }).execute();
            streams.logStreams.should.be.an('array').with.lengthOf(2);
        });
    }
    'revert method should be a no-op'() {
        return __awaiter(this, void 0, void 0, function* () {
            const command = new src_1.ReadLog({
                logStreamName: 'readLog',
            });
            yield command.execute();
            const result = yield command.revert();
            (result === undefined).should.be.equal(true);
        });
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], Test.prototype, "can list all streams", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], Test.prototype, "revert method should be a no-op", null);
Test = __decorate([
    mocha_typescript_1.suite('commands-logging::ListStreams')
], Test);
exports.Test = Test;
//# sourceMappingURL=list_streams.js.map